# __gnu_cxx::stdio_filebuf< CharT, Traits > Class Template Reference

Provides a layer of compatibility for C/POSIX. More...

`#include <ext/stdio_filebuf.h>`

Inheritance diagram for __gnu_cxx::stdio_filebuf< CharT, Traits >:

[legend]
Collaboration diagram for __gnu_cxx::stdio_filebuf< CharT, Traits >:

[legend]
List of all members.

## [NOHEADER]

locale | pubimbue (const locale &__loc)
| Entry point for imbue().
locale | getloc () const
| Locale access.
char_type * | M_in_beg
| Entry point for imbue().
char_type * | M_in_cur
| Entry point for imbue().
char_type * | M_in_end
| Entry point for imbue().
char_type * | M_out_beg
| Entry point for imbue().
char_type * | M_out_cur
| Entry point for imbue().
char_type * | M_out_end
| Entry point for imbue().
locale | M_buf_locale
| Entry point for imbue().

## Public Types

typedef CharT | char_type
typedef Traits | traits_type
typedef traits_type::int_type | int_type
typedef traits_type::pos_type | pos_type
typedef traits_type::off_type | off_type

## Public Member Functions

| stdio_filebuf ()
| stdio_filebuf (int __fd, std::ios_base::openmode __mode, size_t size=static_cast< size_t >(BUFSIZ))
| stdio_filebuf (std::c_file *__f, std::ios_base::openmode __mode, size_t size=static_cast< size_t >(BUFSIZ))
virtual | ~stdio_filebuf ()
int | fd ()
std::c_file * | file ()
bool | is_open () const throw ()
| Returns true if the external file is open.
__filebuf_type * | open (const char *s, ios_base::openmode __mode)
| Opens an external file.
__filebuf_type * | close () throw ()
| Closes the currently associated file.
streamsize | in_avail ()
| Looking ahead into the stream.
int_type | snextc ()
| Getting the next character.
int_type | sbumpc ()
| Getting the next character.
int_type | sgetc ()
| Getting the next character.
streamsize | sgetn (char_type *s, streamsize n)
| Entry point for xsgetn.
int_type | sputbackc (char_type c)
| Pushing characters back into the input stream.
int_type | sungetc ()
| Moving backwards in the input stream.
int_type | sputc (char_type c)
| Entry point for all single-character output functions.
streamsize | sputn (const char_type *s, streamsize n)
| Entry point for all single-character output functions.
streambuf_type * | pubsetbuf (char_type *s, streamsize n)
| Entry points for derived buffer functions.
pos_type | pubseekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
| Entry points for derived buffer functions.
pos_type | pubseekpos (pos_type sp, ios_base::openmode __mode=ios_base::in|ios_base::out)
| Entry points for derived buffer functions.
int | pubsync ()
| Entry points for derived buffer functions.

## Protected Member Functions

virtual streamsize | showmanyc ()
| Investigating the data available.
virtual int_type | underflow ()
| Fetches more data from the controlled sequence.
virtual int_type | pbackfail (int_type c=Traits::eof())
| Tries to back up the input sequence.
virtual int_type | overflow (int_type c=Traits::eof())
| Consumes data from the buffer; writes to the controlled sequence.
virtual streambuf_type * | setbuf (char_type *s, streamsize n)
| Manipulates the buffer.
virtual pos_type | seekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
| Alters the stream positions.
virtual pos_type | seekpos (pos_type position, ios_base::openmode __mode=ios_base::in|ios_base::out)
| Alters the stream positions.
virtual int | sync ()
| Synchronizes the buffer arrays with the controlled sequences.
virtual void | imbue (const locale &__loc)
| Changes translations.
virtual streamsize | xsgetn (char_type *s, streamsize n)
| Multiple character extraction.
virtual streamsize | xsputn (const char_type *s, streamsize n)
| Multiple character insertion.
void | gbump (int n)
| Moving the read position.
void | setg (char_type *__gbeg, char_type *__gnext, char_type *__gend)
| Setting the three read area pointers.
void | pbump (int n)
| Moving the write position.
void | setp (char_type *__pbeg, char_type *__pend)
| Setting the three write area pointers.
virtual int_type | uflow ()
| Fetches more data from the controlled sequence.
char_type * | eback () const
| Access to the get area.
char_type * | gptr () const
| Access to the get area.
char_type * | egptr () const
| Access to the get area.
char_type * | pbase () const
| Access to the put area.
char_type * | pptr () const
| Access to the put area.
char_type * | epptr () const
| Access to the put area.

## Detailed Description

### template<typename CharT, typename Traits = std::char_traits<CharT>>
class __gnu_cxx::stdio_filebuf< CharT, Traits >

Provides a layer of compatibility for C/POSIX.

This GNU extension provides extensions for working with standard C FILE*'s and POSIX file descriptors. It must be instantiated by the user with the type of character used in the file stream, e.g., stdio_filebuf<char>.

Definition at line 53 of file stdio_filebuf.h.

## Member Typedef Documentation

template<typename CharT, typename Traits = std::char_traits<CharT>>
typedef CharT __gnu_cxx::stdio_filebuf< CharT, Traits >::char_type

| These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation. Reimplemented from std::basic_filebuf< CharT, Traits >. Definition at line 57 of file stdio_filebuf.h.

template<typename CharT, typename Traits = std::char_traits<CharT>>
typedef traits_type::int_type __gnu_cxx::stdio_filebuf< CharT, Traits >::int_type

| These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation. Reimplemented from std::basic_filebuf< CharT, Traits >. Definition at line 59 of file stdio_filebuf.h.

template<typename CharT, typename Traits = std::char_traits<CharT>>
typedef traits_type::off_type __gnu_cxx::stdio_filebuf< CharT, Traits >::off_type

| These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation. Reimplemented from std::basic_filebuf< CharT, Traits >. Definition at line 61 of file stdio_filebuf.h.

template<typename CharT, typename Traits = std::char_traits<CharT>>
typedef traits_type::pos_type __gnu_cxx::stdio_filebuf< CharT, Traits >::pos_type

| These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation. Reimplemented from std::basic_filebuf< CharT, Traits >. Definition at line 60 of file stdio_filebuf.h.

template<typename CharT, typename Traits = std::char_traits<CharT>>
typedef Traits __gnu_cxx::stdio_filebuf< CharT, Traits >::traits_type

| These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation. Reimplemented from std::basic_filebuf< CharT, Traits >. Definition at line 58 of file stdio_filebuf.h.

## Constructor & Destructor Documentation

template<typename CharT, typename Traits = std::char_traits<CharT>>
__gnu_cxx::stdio_filebuf< CharT, Traits >::stdio_filebuf | ( |  | ) | `[inline]`

| deferred initialization Definition at line 68 of file stdio_filebuf.h.

template<typename CharT, typename Traits>
__gnu_cxx::stdio_filebuf< CharT, Traits >::stdio_filebuf | ( | int | __fd,
|  | std::ios_base::openmode | __mode,
|  | size_t | size = `static_cast< size_t >(BUFSIZ)`
| ) |

Parameters:

  | fd | An open file descriptor.
  | mode | Same meaning as in a standard filebuf.
  | size | Optimal or preferred size of internal buffer, in chars.

This constructor associates a file stream buffer with an open POSIX file descriptor. The file descriptor will be automatically closed when the stdio_filebuf is closed/destroyed.

Definition at line 130 of file stdio_filebuf.h.

References std::basic_filebuf< CharT, Traits >::is_open(), and std::ios_base::openmode.

template<typename CharT, typename Traits>
__gnu_cxx::stdio_filebuf< CharT, Traits >::stdio_filebuf | ( | std::c_file * | __f,
|  | std::ios_base::openmode | __mode,
|  | size_t | size = `static_cast< size_t >(BUFSIZ)`
| ) |

Parameters:

  | f | An open `FILE*`.
  | mode | Same meaning as in a standard filebuf.
  | size | Optimal or preferred size of internal buffer, in chars. Defaults to system's `BUFSIZ`.

This constructor associates a file stream buffer with an open C `FILE*`. The `FILE*` will not be automatically closed when the stdio_filebuf is closed/destroyed.

Definition at line 146 of file stdio_filebuf.h.

References std::basic_filebuf< CharT, Traits >::is_open().

template<typename CharT, typename Traits>
__gnu_cxx::stdio_filebuf< CharT, Traits >::~stdio_filebuf | ( |  | ) | `[virtual]`

| Closes the external data stream if the file descriptor constructor was used. Definition at line 125 of file stdio_filebuf.h.

## Member Function Documentation

template<typename CharT, typename Traits>
basic_filebuf< CharT, Traits >::__filebuf_type * std::basic_filebuf< CharT, Traits >::close | ( |  | ) | throw ()`[inherited]`

Closes the currently associated file.

Returns:
  `this` on success, NULL on failure

If no file is currently open, this function immediately fails.

If a "put buffer area" exists, `overflow(eof)` is called to flush all the characters. The file is then closed.

If any operations fail, this function also fails.

Definition at line 125 of file fstream.tcc.

References std::basic_filebuf< CharT, Traits >::is_open().

Referenced by std::basic_filebuf< CharT, Traits >::open().

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::eback | ( |  | ) | const`[inline, protected, inherited]`

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 452 of file streambuf.

Referenced by std::basic_filebuf< CharT, Traits >::imbue(), std::basic_stringbuf< CharT, Traits, Alloc >::overflow(), std::basic_stringbuf< CharT, Traits, Alloc >::pbackfail(), std::basic_filebuf< CharT, Traits >::pbackfail(), std::basic_stringbuf< CharT, Traits, Alloc >::seekoff(), std::basic_filebuf< CharT, Traits >::seekoff(), std::basic_stringbuf< CharT, Traits, Alloc >::seekpos(), std::basic_streambuf< CharT, enc_char_traits< CharT > >::sputbackc(), and std::basic_filebuf< CharT, Traits >::underflow().

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::egptr | ( |  | ) | const`[inline, protected, inherited]`

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 458 of file streambuf.

Referenced by std::basic_streambuf< CharT, enc_char_traits< CharT > >::in_avail(), std::basic_streambuf< CharT, enc_char_traits< CharT > >::sbumpc(), std::basic_stringbuf< CharT, Traits, Alloc >::seekoff(), std::basic_filebuf< CharT, Traits >::seekoff(), std::basic_stringbuf< CharT, Traits, Alloc >::seekpos(), std::basic_streambuf< CharT, enc_char_traits< CharT > >::sgetc(), std::basic_filebuf< CharT, Traits >::showmanyc(), std::basic_stringbuf< CharT, Traits, Alloc >::str(), std::basic_stringbuf< CharT, Traits, Alloc >::underflow(), std::basic_filebuf< CharT, Traits >::underflow(), and std::basic_streambuf< CharT, Traits >::xsgetn().

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::epptr | ( |  | ) | const`[inline, protected, inherited]`

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 505 of file streambuf.

Referenced by std::basic_stringbuf< CharT, Traits, Alloc >::overflow(), std::basic_streambuf< CharT, enc_char_traits< CharT > >::sputc(), and std::basic_streambuf< CharT, Traits >::xsputn().

template<typename CharT, typename Traits = std::char_traits<CharT>>
int __gnu_cxx::stdio_filebuf< CharT, Traits >::fd | ( |  | ) | `[inline]`

Returns:
  The underlying file descriptor.

Once associated with an external data stream, this function can be used to access the underlying POSIX file descriptor. Note that there is no way for the library to track what you do with the descriptor, so be careful.

Definition at line 111 of file stdio_filebuf.h.

template<typename CharT, typename Traits = std::char_traits<CharT>>
std::c_file* __gnu_cxx::stdio_filebuf< CharT, Traits >::file | ( |  | ) | `[inline]`

Returns:
  The underlying FILE*.

This function can be used to access the underlying "C" file pointer. Note that there is no way for the library to track what you do with the file, so be careful.

Definition at line 121 of file stdio_filebuf.h.

template<typename CharT, typename Traits>
void std::basic_streambuf< CharT, Traits >::gbump | ( | int | n | ) | `[inline, protected, inherited]`

Moving the read position.

Parameters:

  | n | The delta by which to move.

This just advances the read position without returning any data.

Definition at line 468 of file streambuf.

Referenced by std::basic_streambuf< CharT, Traits >::xsgetn().

template<typename CharT, typename Traits>
locale std::basic_streambuf< CharT, Traits >::getloc | ( |  | ) | const`[inline, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 215 of file streambuf.

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::gptr | ( |  | ) | const`[inline, protected, inherited]`

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 455 of file streambuf.

Referenced by std::basic_streambuf< CharT, enc_char_traits< CharT > >::in_avail(), std::basic_stringbuf< CharT, Traits, Alloc >::overflow(), std::basic_stringbuf< CharT, Traits, Alloc >::pbackfail(), std::basic_filebuf< CharT, Traits >::pbackfail(), std::basic_stringbuf< CharT, Traits, Alloc >::seekoff(), std::basic_filebuf< CharT, Traits >::seekoff(), std::basic_filebuf< CharT, Traits >::showmanyc(), std::basic_streambuf< CharT, enc_char_traits< CharT > >::sputbackc(), std::basic_streambuf< CharT, enc_char_traits< CharT > >::sungetc(), std::basic_stringbuf< CharT, Traits, Alloc >::underflow(), std::basic_filebuf< CharT, Traits >::underflow(), and std::basic_streambuf< CharT, Traits >::xsgetn().

template<typename CharT, typename Traits>
void std::basic_filebuf< CharT, Traits >::imbue | ( | const locale & | __loc | ) | `[protected, virtual, inherited]`

Changes translations.

Parameters:

  | loc | A new locale.

Translations done during I/O which depend on the current locale are changed by this call. The standard adds, "Between invocations of this function a class derived from streambuf can safely cache results of calls to locale functions and to members of facets so obtained."

Note:
  Base class version does nothing.

Reimplemented from std::basic_streambuf< CharT, Traits >.

Definition at line 741 of file fstream.tcc.

References std::basic_streambuf< CharT, Traits >::eback(), std::basic_filebuf< CharT, Traits >::is_open(), std::basic_filebuf< CharT, Traits >::off_type, std::basic_filebuf< CharT, Traits >::seekoff(), and std::streamsize.

template<typename CharT, typename Traits>
streamsize std::basic_streambuf< CharT, Traits >::in_avail | ( |  | ) | `[inline, inherited]`

Looking ahead into the stream.

Returns:
  The number of characters available.

If a read position is available, returns the number of characters available for reading before the buffer must be refilled. Otherwise returns the derived `showmanyc()`.

Definition at line 255 of file streambuf.

template<typename CharT, typename Traits>
bool std::basic_filebuf< CharT, Traits >::is_open | ( |  | ) | const throw ()`[inline, inherited]`

Returns true if the external file is open.

Definition at line 292 of file fstream.

Referenced by std::basic_filebuf< CharT, Traits >::close(), std::basic_filebuf< CharT, Traits >::imbue(), std::basic_filebuf< CharT, Traits >::open(), std::basic_filebuf< CharT, Traits >::seekoff(), std::basic_filebuf< CharT, Traits >::seekpos(), std::basic_filebuf< CharT, Traits >::setbuf(), std::basic_filebuf< CharT, Traits >::showmanyc(), and __gnu_cxx::stdio_filebuf< CharT, Traits >::stdio_filebuf().

template<typename CharT, typename Traits>
basic_filebuf< CharT, Traits >::__filebuf_type * std::basic_filebuf< CharT, Traits >::open | ( | const char * | s,
|  | ios_base::openmode | __mode
| ) | `[inherited]`

Opens an external file.

Parameters:

  | s | The name of the file.
  | mode | The open mode flags.

Returns:
  `this` on success, NULL on failure

If a file is already open, this function immediately fails. Otherwise it tries to open the file named s using the flags given in mode.

[Table 92 gives the relation between openmode combinations and the equivalent fopen() flags, but the table has not been copied yet.]

Definition at line 91 of file fstream.tcc.

References std::basic_filebuf< CharT, Traits >::close(), std::basic_filebuf< CharT, Traits >::is_open(), std::basic_filebuf< CharT, Traits >::off_type, std::basic_filebuf< CharT, Traits >::pos_type, and std::basic_filebuf< CharT, Traits >::seekoff().

template<typename CharT, typename Traits>
basic_filebuf< CharT, Traits >::int_type std::basic_filebuf< CharT, Traits >::overflow | ( | int_type | c = `Traits::eof()` | ) | `[protected, virtual, inherited]`

Consumes data from the buffer; writes to the controlled sequence.

Parameters:

  | c | An additional character to consume.

Returns:
  eof() to indicate failure, something else (usually c, or not_eof())

Informally, this function is called when the output buffer is full (or does not exist, as buffering need not actually be done). If a buffer exists, it is "consumed", with "some effect" on the controlled sequence. (Typically, the buffer is written out to the sequence verbatim.) In either case, the character c is also written out, if c is not `eof()`.

For a formal definiton of this function, see a good text such as Langer & Kreft, or [27.5.2.4.5]/3-7.

A functioning output streambuf can be created by overriding only this function (no buffer area will be used).

Note:
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< CharT, Traits >.

Definition at line 380 of file fstream.tcc.

References std::basic_filebuf< CharT, Traits >::char_type, std::basic_filebuf< CharT, Traits >::int_type, std::basic_streambuf< CharT, Traits >::pbase(), and std::basic_streambuf< CharT, Traits >::pptr().

template<typename CharT, typename Traits>
basic_filebuf< CharT, Traits >::int_type std::basic_filebuf< CharT, Traits >::pbackfail | ( | int_type | __i = `Traits::eof()` | ) | `[protected, virtual, inherited]`

Tries to back up the input sequence.

Parameters:

  | c | The character to be inserted back into the sequence.

Returns:
  eof() on failure, "some other value" on success

Postcondition:
  The constraints of `gptr()`, `eback()`, and `pptr()` are the same as for `underflow()`.

Note:
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< CharT, Traits >.

Definition at line 328 of file fstream.tcc.

References std::basic_streambuf< CharT, Traits >::eback(), std::basic_streambuf< CharT, Traits >::gptr(), std::basic_filebuf< CharT, Traits >::int_type, std::basic_filebuf< CharT, Traits >::off_type, std::basic_filebuf< CharT, Traits >::pos_type, std::basic_filebuf< CharT, Traits >::seekoff(), and std::basic_filebuf< CharT, Traits >::underflow().

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::pbase | ( |  | ) | const`[inline, protected, inherited]`

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 499 of file streambuf.

Referenced by std::basic_stringbuf< CharT, Traits, Alloc >::overflow(), std::basic_filebuf< CharT, Traits >::overflow(), std::basic_stringbuf< CharT, Traits, Alloc >::seekoff(), std::basic_stringbuf< CharT, Traits, Alloc >::seekpos(), and std::basic_filebuf< CharT, Traits >::sync().

template<typename CharT, typename Traits>
void std::basic_streambuf< CharT, Traits >::pbump | ( | int | n | ) | `[inline, protected, inherited]`

Moving the write position.

Parameters:

  | n | The delta by which to move.

This just advances the write position without returning any data.

Definition at line 515 of file streambuf.

Referenced by std::basic_streambuf< CharT, Traits >::xsputn().

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::pptr | ( |  | ) | const`[inline, protected, inherited]`

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 502 of file streambuf.

Referenced by std::basic_stringbuf< CharT, Traits, Alloc >::overflow(), std::basic_filebuf< CharT, Traits >::overflow(), std::basic_stringbuf< CharT, Traits, Alloc >::seekoff(), std::basic_streambuf< CharT, enc_char_traits< CharT > >::sputc(), std::basic_stringbuf< CharT, Traits, Alloc >::str(), std::basic_filebuf< CharT, Traits >::sync(), and std::basic_streambuf< CharT, Traits >::xsputn().

template<typename CharT, typename Traits>
locale std::basic_streambuf< CharT, Traits >::pubimbue | ( | const locale & | __loc | ) | `[inline, inherited]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 198 of file streambuf.

template<typename CharT, typename Traits>
pos_type std::basic_streambuf< CharT, Traits >::pubseekoff | ( | off_type | __off,
|  | ios_base::seekdir | __way,
|  | ios_base::openmode | __mode = `ios_base::in | ios_base::out`
| ) | `[inline, inherited]`

| Entry points for derived buffer functions. The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged. Definition at line 232 of file streambuf.

template<typename CharT, typename Traits>
pos_type std::basic_streambuf< CharT, Traits >::pubseekpos | ( | pos_type | sp,
|  | ios_base::openmode | __mode = `ios_base::in | ios_base::out`
| ) | `[inline, inherited]`

| Entry points for derived buffer functions. The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged. Definition at line 237 of file streambuf.

template<typename CharT, typename Traits>
streambuf_type* std::basic_streambuf< CharT, Traits >::pubsetbuf | ( | char_type * | s,
|  | streamsize | n
| ) | `[inline, inherited]`

| Entry points for derived buffer functions. The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged. Definition at line 228 of file streambuf.

template<typename CharT, typename Traits>
int std::basic_streambuf< CharT, Traits >::pubsync | ( |  | ) | `[inline, inherited]`

| Entry points for derived buffer functions. The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged. Definition at line 242 of file streambuf.

template<typename CharT, typename Traits>
int_type std::basic_streambuf< CharT, Traits >::sbumpc | ( |  | ) | `[inline, inherited]`

Getting the next character.

Returns:
  The next character, or eof.

If the input read position is available, returns that character and increments the read pointer, otherwise calls and returns `uflow()`.

Definition at line 287 of file streambuf.

Referenced by std::operator>>().

template<typename CharT, typename Traits>
basic_filebuf< CharT, Traits >::pos_type std::basic_filebuf< CharT, Traits >::seekoff | ( | off_type | __off,
|  | ios_base::seekdir | __way,
|  | ios_base::openmode | __mode = `ios_base::in | ios_base::out`
| ) | `[protected, virtual, inherited]`

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note:
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented from std::basic_streambuf< CharT, Traits >.

Definition at line 574 of file fstream.tcc.

References std::basic_streambuf< CharT, Traits >::eback(), std::basic_streambuf< CharT, Traits >::egptr(), std::basic_streambuf< CharT, Traits >::gptr(), std::basic_filebuf< CharT, Traits >::is_open(), std::basic_filebuf< CharT, Traits >::off_type, std::basic_filebuf< CharT, Traits >::pos_type, and std::ios_base::seekdir.

Referenced by std::basic_filebuf< CharT, Traits >::imbue(), std::basic_filebuf< CharT, Traits >::open(), and std::basic_filebuf< CharT, Traits >::pbackfail().

template<typename CharT, typename Traits>
basic_filebuf< CharT, Traits >::pos_type std::basic_filebuf< CharT, Traits >::seekpos | ( | pos_type | position,
|  | ios_base::openmode | __mode = `ios_base::in | ios_base::out`
| ) | `[protected, virtual, inherited]`

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note:
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented from std::basic_streambuf< CharT, Traits >.

Definition at line 627 of file fstream.tcc.

References std::basic_filebuf< CharT, Traits >::is_open(), std::basic_filebuf< CharT, Traits >::off_type, and std::basic_filebuf< CharT, Traits >::pos_type.

template<typename CharT, typename Traits>
basic_filebuf< CharT, Traits >::streambuf_type * std::basic_filebuf< CharT, Traits >::setbuf | ( | char_type * | s,
|  | streamsize | n
| ) | `[protected, virtual, inherited]`

Manipulates the buffer.

Parameters:

  | s | Pointer to a buffer area.
  | n | Size of s.

Returns:
  `this`

If no file has been opened, and both s and n are zero, then the stream becomes unbuffered. Otherwise, `s` is used as a buffer; see http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#2 for more.

Reimplemented from std::basic_streambuf< CharT, Traits >.

Definition at line 547 of file fstream.tcc.

References std::basic_filebuf< CharT, Traits >::is_open().

template<typename CharT, typename Traits>
void std::basic_streambuf< CharT, Traits >::setg | ( | char_type * | __gbeg,
|  | char_type * | __gnext,
|  | char_type * | __gend
| ) | `[inline, protected, inherited]`

Setting the three read area pointers.

Parameters:

  | gbeg | A pointer.
  | gnext | A pointer.
  | gend | A pointer.

Postcondition:
  gbeg == `eback()`, gnext == `gptr()`, and gend == `egptr()`

Definition at line 479 of file streambuf.

template<typename CharT, typename Traits>
void std::basic_streambuf< CharT, Traits >::setp | ( | char_type * | __pbeg,
|  | char_type * | __pend
| ) | `[inline, protected, inherited]`

Setting the three write area pointers.

Parameters:

  | pbeg | A pointer.
  | pend | A pointer.

Postcondition:
  pbeg == `pbase()`, pbeg == `pptr()`, and pend == `epptr()`

Definition at line 525 of file streambuf.

template<typename CharT, typename Traits>
int_type std::basic_streambuf< CharT, Traits >::sgetc | ( |  | ) | `[inline, inherited]`

Getting the next character.

Returns:
  The next character, or eof.

If the input read position is available, returns that character, otherwise calls and returns `underflow()`. Does not move the read position after fetching the character.

Definition at line 309 of file streambuf.

Referenced by std::basic_streambuf< CharT, enc_char_traits< CharT > >::snextc().

template<typename CharT, typename Traits>
streamsize std::basic_streambuf< CharT, Traits >::sgetn | ( | char_type * | s,
|  | streamsize | n
| ) | `[inline, inherited]`

Entry point for xsgetn.

Parameters:

  | s | A buffer area.
  | n | A count.

Returns xsgetn(s,n). The effect is to fill s[0] through s[n-1] with characters from the input sequence, if possible.

Definition at line 328 of file streambuf.

template<typename CharT, typename Traits>
streamsize std::basic_filebuf< CharT, Traits >::showmanyc | ( |  | ) | `[protected, virtual, inherited]`

Investigating the data available.

Returns:
  An estimate of the number of characters available in the input sequence, or -1.

"If it returns a positive value, then successive calls to `underflow()` will not return `traits::eof()` until at least that number of characters have been supplied. If `showmanyc()` returns -1, then calls to `underflow()` or `uflow()` will fail." [27.5.2.4.3]/1

Note:
  Base class version does nothing, returns zero.

  The standard adds that "the intention is not only that the calls [to underflow or uflow] will not return `eof()` but that they will return "immediately".

  The standard adds that "the morphemes of `showmanyc` are "es-how-many-see", not "show-manic".

Reimplemented from std::basic_streambuf< CharT, Traits >.

Definition at line 160 of file fstream.tcc.

References std::basic_streambuf< CharT, Traits >::egptr(), std::basic_streambuf< CharT, Traits >::gptr(), std::basic_filebuf< CharT, Traits >::is_open(), and std::streamsize.

template<typename CharT, typename Traits>
int_type std::basic_streambuf< CharT, Traits >::snextc | ( |  | ) | `[inline, inherited]`

Getting the next character.

Returns:
  The next character, or eof.

Calls `sbumpc()`, and if that function returns `traits::eof()`, so does this function. Otherwise, `sgetc()`.

Definition at line 269 of file streambuf.

template<typename CharT, typename Traits>
int_type std::basic_streambuf< CharT, Traits >::sputbackc | ( | char_type | c | ) | `[inline, inherited]`

Pushing characters back into the input stream.

Parameters:

  | c | The character to push back.

Returns:
  The previous character, if possible.

Similar to sungetc(), but c is pushed onto the stream instead of "the previous character". If successful, the next character fetched from the input stream will be c.

Definition at line 342 of file streambuf.

Referenced by std::operator>>().

template<typename CharT, typename Traits>
int_type std::basic_streambuf< CharT, Traits >::sputc | ( | char_type | c | ) | `[inline, inherited]`

Entry point for all single-character output functions.

Parameters:

  | c | A character to output.

Returns:
  c, if possible.

One of two public output functions.

If a write position is available for the output sequence (i.e., the buffer is not full), stores c in that position, increments the position, and returns `traits::to_int_type(c)`. If a write position is not available, returns `overflow(c)`.

Definition at line 394 of file streambuf.

template<typename CharT, typename Traits>
streamsize std::basic_streambuf< CharT, Traits >::sputn | ( | const char_type * | s,
|  | streamsize | n
| ) | `[inline, inherited]`

Entry point for all single-character output functions.

Parameters:

  | s | A buffer read area.
  | n | A count.

One of two public output functions.

Returns xsputn(s,n). The effect is to write s[0] through s[n-1] to the output sequence, if possible.

Definition at line 420 of file streambuf.

template<typename CharT, typename Traits>
int_type std::basic_streambuf< CharT, Traits >::sungetc | ( |  | ) | `[inline, inherited]`

Moving backwards in the input stream.

Returns:
  The previous character, if possible.

If a putback position is available, this function decrements the input pointer and returns that character. Otherwise, calls and returns pbackfail(). The effect is to "unget" the last character "gotten".

Definition at line 367 of file streambuf.

template<typename CharT, typename Traits>
int std::basic_filebuf< CharT, Traits >::sync | ( |  | ) | `[protected, virtual, inherited]`

Synchronizes the buffer arrays with the controlled sequences.

Returns:
  -1 on failure.

Each derived class provides its own appropriate behavior, including the definition of "failure".

Note:
  Base class version does nothing, returns zero.

Reimplemented from std::basic_streambuf< CharT, Traits >.

Definition at line 723 of file fstream.tcc.

References std::basic_filebuf< CharT, Traits >::int_type, std::basic_streambuf< CharT, Traits >::pbase(), and std::basic_streambuf< CharT, Traits >::pptr().

template<typename CharT, typename Traits>
virtual int_type std::basic_streambuf< CharT, Traits >::uflow | ( |  | ) | `[inline, protected, virtual, inherited]`

Fetches more data from the controlled sequence.

Returns:
  The first character from the pending sequence.

Informally, this function does the same thing as `underflow()`, and in fact is required to call that function. It also returns the new character, like `underflow()` does. However, this function also moves the read position forward by one.

Definition at line 670 of file streambuf.

Referenced by std::basic_streambuf< CharT, enc_char_traits< CharT > >::sbumpc(), and std::basic_streambuf< CharT, Traits >::xsgetn().

template<typename CharT, typename Traits>
basic_filebuf< CharT, Traits >::int_type std::basic_filebuf< CharT, Traits >::underflow | ( |  | ) | `[protected, virtual, inherited]`

Fetches more data from the controlled sequence.

Returns:
  The first character from the pending sequence.

Informally, this function is called when the input buffer is exhausted (or does not exist, as buffering need not actually be done). If a buffer exists, it is "refilled". In either case, the next available character is returned, or `traits::eof()` to indicate a null pending sequence.

For a formal definiton of the pending sequence, see a good text such as Langer & Kreft, or [27.5.2.4.3]/7-14.

A functioning input streambuf can be created by overriding only this function (no buffer area will be used). For an example, see http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#6

Note:
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< CharT, Traits >.

Definition at line 178 of file fstream.tcc.

References std::basic_filebuf< CharT, Traits >::char_type, std::basic_streambuf< CharT, Traits >::eback(), std::basic_streambuf< CharT, Traits >::egptr(), std::basic_streambuf< CharT, Traits >::gptr(), std::basic_filebuf< CharT, Traits >::int_type, std::min(), and std::streamsize.

Referenced by std::basic_filebuf< CharT, Traits >::pbackfail().

template<typename CharT, typename Traits>
virtual streamsize std::basic_filebuf< CharT, Traits >::xsgetn | ( | char_type * | s,
|  | streamsize | n
| ) | `[inline, protected, virtual, inherited]`

Multiple character extraction.

Parameters:

  | s | A buffer area.
  | n | Maximum number of characters to assign.

Returns:
  The number of characters assigned.

Fills s[0] through s[n-1] with characters from the input sequence, as if by `sbumpc()`. Stops when either n characters have been copied, or when `traits::eof()` would be copied.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented from std::basic_streambuf< CharT, Traits >.

Definition at line 433 of file fstream.

template<typename CharT, typename Traits>
virtual streamsize std::basic_filebuf< CharT, Traits >::xsputn | ( | const char_type * | s,
|  | streamsize | n
| ) | `[protected, virtual, inherited]`

Multiple character insertion.

Parameters:

  | s | A buffer area.
  | n | Maximum number of characters to write.

Returns:
  The number of characters written.

Writes s[0] through s[n-1] to the output sequence, as if by `sputc()`. Stops when either n characters have been copied, or when `sputc()` would return `traits::eof()`.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented from std::basic_streambuf< CharT, Traits >.

## Member Data Documentation

template<typename CharT, typename Traits>
locale std::basic_streambuf< CharT, Traits >::M_buf_locale `[protected, inherited]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 181 of file streambuf.

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::M_in_beg `[protected, inherited]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 169 of file streambuf.

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::M_in_cur `[protected, inherited]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 170 of file streambuf.

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::M_in_end `[protected, inherited]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 171 of file streambuf.

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::M_out_beg `[protected, inherited]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 172 of file streambuf.

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::M_out_cur `[protected, inherited]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 173 of file streambuf.

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::M_out_end `[protected, inherited]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 174 of file streambuf.

The documentation for this class was generated from the following file:

- stdio_filebuf.h